// Copyright (C) 2007 Daniel Dalevi
// Distributed under the GNU GENERAL PUBLIC LICENSE version 2

#include <string>

namespace Helper
{
  string getVersion()
  {
    return std::string( "(1,0,19)" );
  }

  string getDate()
  {
    return std::string( "30 April 2007" );
  }
  
  void displayVersion( const string& prog )
  {
    cout << prog << " version " << getVersion() << "\n"
	 << "Last modified: " << getDate() << "\n";
  }

  void displayShortHelp( const string& prog )
  {
    cout << "Type, " << prog << " -h, for help\n";
  }
  
  void displayHelp( const string& prog ) 
  {
    cout << "----------------------------------------------------------------------\n"
	 << "GrUNT - Grouping /  Ungrouping Namming Tool\n"
	 << "Version " << getVersion() << ", last update " << getDate() << endl
	 << "A software for automatic assignment of groupnames to 16S trees\n"
	 << "maintained by ARB and Greengenes\n"
	 << "Written by: Daniel Dalevi\n"
	 << "----------------------------------------------------------------------\n"
	 << "Syntax:\n"
	 << prog << " -f tree.xml <options>\n"
	 << "----------------------------------------------------------------------\n"
	 << "Type of analysis:\n"
	 << "-addG:  Adding groupnames.\n"
	 << "-rmvG:  Removing groupnames.\n"
	 << "-showG: Will print groupnames  of tree in file \"-f\" to the output file \"-o\"\n"
	 << "-shLS:  Same as showG but will output branch lengths with support values.\n"
	 << "Options:\n"
	 << "-f:  In file in ARB's xml formate.\n"
	 << "-o:  Out file            (out.xml, or out.txt if \"-shLS\")\n"
	 << "-lf: Log file            (log.txt)\n"
	 << "-hf: \"Holy names\". File with groupnames that cannot be removed\n"
	 << "     from tree. Entries are listed as rows, one by one.\n"
	 << "     If no file is specified, no groups names are \"holy\"\n"
	 << "    Another file will also be produced called RED_*.xml\n"
	 << "-pf: Pattern file \n"
	 << "     File with specific words that a groupname cannot contain.\n"
	 << "     The option is used when removing groups. For example, \n"
	 << "     if specifying \"XXX\", all groupnames that contain this\n"
	 << "     pattern will be removed.\n"
	 << "-mC: Minimum count of taxa in group (10)\n"
	 << "-mL: Minimum branch length, a negative number means inactive (0.02)\n"
	 << "-mS: Minimum bootstrap support, a negative number means inactive (-1)\n"    
	 << "----------------------------------------------------------------------\n"
	 << "Example syntax:\n"
	 << prog << " -addG -f Cyano.xml -o out.xml -mC 10 -mL 0.001 -mS 75\n"
	 << prog << " -rmvG -f Cyano_isolates.xml -pf notallowed.txt -mL 0.01\n"
	 << prog << " -showG -f Cyano_isolates.xml -o group_list.txt\n"
	 << prog << " -shLS -f Cyano_isolates.xml -o lengths_and_support.txt\n"
	 << "----------------------------------------------------------------------\n";
  }
}
















