// Copyright (C) 2007 Daniel Dalevi
// Distributed under the GNU GENERAL PUBLIC LICENSE version 2

#ifndef xxxMYXMLPARSERxxx
#define xxxMYXMLPARSERxxx



// Class for parsing the XML files output from ARB
// This code is very specific for a purpose and 
// do not work generaly for XML files.


#include <vector>
#include <string>
#include <fstream>
#include <cmath>
#include <iostream>
#include <RandomSingleton.h>
#include <Exception.h>
#include "Node.h"


using namespace std;

class MyXMLParser {
  const static int MAXLINEWIDTH = 10000;

public:  
  MyXMLParser();
  void readFromFile( const string& file );
  void setForbiddenPatternsFromFile( const string& );
  void setLogFile( const string& file );
  void print();
  void print( ofstream&, const bool& );
  void printGroups( ofstream& fout );
  void printLandS( ofstream& );
  void strip( string& );
  void print( Node* );
  void removeSpaces( string& );
  void removeDots( string& );
  string selectAttribute( const vector<Node*>&  );
  int addGroupNames( const int& mc, const double& mL, const int& mS );
  int removeGroupNames( const double& mL, const int& mS );
  void getItemsBelow( vector<Node*>::iterator, vector<Node*>::iterator, vector<Node*>& );
  void setHolyNamesFromFile( const string& );
  string month2number( const string& );
  string getOldestSequence( const vector<string>&, 
			    const vector<string>&, 
			    const vector<string>&, 
			    const string& non_pref_type = "" );
  bool fulfillRequirements( string& );
  int getTimeInSeconds();

private:
  vector<Node*> myNodes;
  vector<string> header;
  vector<string> forbiddenPatterns;
  map<string,int> groupsUsed;
  map<string, int> holyNames;
  map<char, bool> toxic;
  ofstream flog;
};

#endif
