#include "Node.h"
#include <Util.h>
#include <StringTokenizer.h>

double Node::maxDepth = 0;

Node::Node()
{  
}

void Node::setAttribute( const string& item, const string& val )
{
  myAttributes[ item ] = val;
}


string Node::getAttribute( const string& item ) 
{
  return myAttributes[ item ];
}


// Returns a string with the xml format of a tag
string Node::getXML()
{
  string res = "";
  if( type == "/BRANCH" ) res += " ";
  res += "<" + type;
  map<string, string>::const_iterator iter;
  for( iter = myAttributes.begin(); iter != myAttributes.end(); ++iter ) 
    {								
      if( iter->second == "" ) continue;
      res += " " + iter->first + "=\"" + iter->second + "\""; 
    }
  //  res += " depth=\"" + Util::ToString( depth ) + "\""; 
  if( type == "ITEM" ) res += "/>";
  else res += ">";
  return res;
}

// The spaces for indenting the xml file
string getSpaces( int r )
{
  string res = "";
  for( int i = 0; i < r; ++i ) res += " ";
  return res;
}

// prints the node to std output
void Node::print()
{
  string spaces = getSpaces( static_cast<int>( depth ) );
  if( type == "ITEM" ) spaces += "  ";
  cout << spaces << getXML() << endl;
}

//prints the node to a file
void Node::print( ofstream& fout, const bool& stripItem )
{
  string spaces = getSpaces( static_cast<int>( depth ) );
  if( type == "ITEM" ) 
    {
      spaces += "  ";
      if( stripItem )
	{
	  string itemname = getAttribute( "itemname" );
	  StringTokenizer myTok( itemname, "," );
	  if( myTok.hasMoreTokens() ) itemname = myTok.nextToken();
	  setAttribute( "itemname", itemname );
	}
    }
  fout << spaces << getXML() << endl;
}

