// Copyright (C) 2007 Daniel Dalevi
// Distributed under the GNU GENERAL PUBLIC LICENSE version 2

#ifndef xxxNODExxx
#define xxxNODExxx


/*
 * Description: This class models a non-homogeneous Markov chain fully 
 * defined by the parameters, pi(i) and K (clumping parameter).
 **/

#include <vector>
#include <string>
#include <fstream>
#include <cmath>
#include <iostream>
#include <RandomSingleton.h>
#include "Node.h"
#include <map>

using namespace std;


class Node {
static double maxDepth;

public:  
  Node();
  void setAttribute( const string& item, const string& val );
  void setDepth( const double& d ) 
  { 
    depth = d; 
    if( depth > maxDepth ) maxDepth = depth;
  }
  double getDepth() const { return depth;}
  string getType() const { return type; }
  string getAttribute( const string& item );
  string getXML();
  void setType( const string& t ) { type = t; }
  void print();
  void print( ofstream&, const bool& );
  static double getMaxDepth() { return maxDepth; }
private:
  map<string, string> myAttributes;
  string type;
  double depth;
};

#endif
